/*!
Hype ZoomCorrector 1.0
copyright (c) 2019 Max Ziebell, (https://maxziebell.de). MIT-license
*/

/*
* Version-History
* 1.0 Initial release under MIT-license
*/
if("HypeZoomCorrector" in window === false) window['HypeZoomCorrector'] = (function () {
	/* check if is IDE */
	function isHypeIDE() {
		var isHypeScratch = window.location.href.indexOf("/Hype/Scratch/HypeScratch.") != -1;
		var hasHypeEditorElm = !!document.getElementById('HypeSceneEditor');
		return isHypeScratch && hasHypeEditorElm;
	}
	/* IDE fix -- START */
	window.addEventListener("DOMContentLoaded", function(event) {
		if (isHypeIDE()) {
			/* temporary workaround as long as the IDE uses zoom on 100% plus */
			var zoomCorrector = function(mutations) {
				mutations.forEach(function(mutation) {
					if (mutation.type == 'attributes') {
						if (mutation.attributeName == 'style') {
							var zoom = mutation.target.style.zoom;
							if (zoom){
								mutation.target.style.zoom = null;
								mutation.target.style.transform = 'scale('+zoom+', '+zoom+')';
								mutation.target.style.transformOrigin = 'left top';
							}
						}
					}
				});
			}
			/* fix zoom in IDE to only use transforms */
			var zoomObserver = new MutationObserver(zoomCorrector);
			var HypeSceneEditorElm = document.getElementById('HypeSceneEditor');
			zoomObserver.observe(HypeSceneEditorElm, { 
				attributes: true,
				attributeOldValue: true,
				attributeFilter: [ "style"]
			});
			/* trigger an initial zoom event */
			zoomCorrector([{
				target: HypeSceneEditorElm,
				type : 'attributes',
				attributeName : 'style'
			}]);
		}
	});
	/* IDE fixnext -- END */
})();